<template>
  <ResizePageWrapper :hasLeft="false">
    <template #resizeRight>
      <BasicTable
        @register="registerTable"
        isMenuTable
        ref="tableRef"
        :row-selection="{ selectedRowKeys: selectedKeys, onChange: onSelectChange }"
      >
        <template #toolbar>
          <template v-for="button in tableButtonConfig" :key="button.code">
            <a-button v-if="button.isDefault" type="primary" @click="buttonClick(button.code)">
              <template #icon>
                <Icon :icon="button.icon" />
              </template>
              {{ button.name }}
            </a-button>
            <CustomButtonModal v-else-if="button.buttonType == 'modal'" :info="button" />
            <a-button
              v-else
              :type="button.buttonType === 'danger' ? 'default' : button.buttonType || 'primary'"
              :danger="button.buttonType === 'danger'"
              @click="buttonClick(button.code)"
            >
              <template #icon>
                <Icon :icon="button.icon" />
              </template>
              {{ button.name }}
            </a-button>
          </template>
        </template>
        <template #bodyCell="{ column, record }">
          <template v-if="column.dataIndex === 'action'">
            <TableAction
              :actions="getLessActions(record)"
              :dropDownActions="getMoreActions(record)"
            />
          </template>

          <template v-else-if="column.dataIndex && column?.listStyle">
            <span :style="executeListStyle(getValue(record, column, 'style'), column?.listStyle)">{{
              getValue(record, column, 'value')
            }}</span>
          </template>
        </template>
      </BasicTable>
    </template>

    <ScjhModal @register="registerModal" @success="handleFormSuccess" @cancel="handleFormCancel" />
  </ResizePageWrapper>
</template>
<script lang="ts" setup>
  import { ref, computed, provide, Ref, createVNode } from 'vue';

  import { Modal } from 'ant-design-vue';
  import { ExclamationCircleOutlined } from '@ant-design/icons-vue';
  import { BasicTable, useTable, TableAction, ActionItem } from '/@/components/Table';
  import {
    getMesProductionPlanPage,
    deleteMesProductionPlan,
    issueMesProductionPlan,
  } from '/@/api/scgl/scjh';
  import { ResizePageWrapper } from '/@/components/Page';
  import { useMessage } from '/@/hooks/web/useMessage';
  import { useI18n } from '/@/hooks/web/useI18n';
  import { usePermission } from '/@/hooks/web/usePermission';
  import CustomButtonModal from '/@/components/Form/src/components/CustomButtonModal.vue';
  import { executeListStyle, getValue } from '/@/hooks/web/useListStyle'; //列表样式配置
  import { useRouter } from 'vue-router';

  import { useModal } from '/@/components/Modal';

  import ScjhModal from './components/ScjhModal.vue';

  import { searchFormSchema, columns } from './components/config';

  import Icon from '/@/components/Icon/index';

  const listSpliceNum = ref(3); //操作列最先展示几个

  import { useConcurrentLock } from '/@/hooks/web/useConcurrentLock';
  import { rksqMesProductOutput } from '/@/api/scgl/ccmx';

  const pageParamsInfo = ref<any>({});
  const {
    enableLockeData,
    handleOpenFormEnableLockeData,
    handleCloseFormEnableLocke,
    handleHasEnableLocke,
  } = useConcurrentLock();

  const { notification } = useMessage();
  const { t } = useI18n();
  defineEmits(['register']);
  const { filterColumnAuth, filterButtonAuth, hasPermission } = usePermission();

  const filterColumns = filterColumnAuth(columns);
  const tableRef = ref();

  //展示在列表内的按钮
  const actionButtons = ref<string[]>(['view', 'edit', 'delete']);
  const buttonConfigs = computed(() => {
    const list = [
      {
        buttonId: '2004396569122545664',
        name: '查看',
        code: 'view',
        icon: 'ant-design:eye-outlined',
        isDefault: true,
        isUse: true,
      },
      {
        buttonId: '2004396569122545665',
        name: '新增',
        code: 'add',
        icon: 'ant-design:plus-outlined',
        isDefault: true,
        isUse: true,
      },
      {
        buttonId: '2004396569122545666',
        name: '编辑',
        code: 'edit',
        icon: 'ant-design:form-outlined',
        isDefault: true,
        isUse: true,
        isEnableLock: true,
      },
      {
        buttonId: '2004471125057142784',
        name: '下发任务',
        code: 'xiafa',
        icon: 'ant-design:export-outlined',
        isDefault: false,
        isUse: true,
        setting: [],
        showType: 'top',
        buttonType: 'primary',
      },
      {
        buttonId: '2004396569122545667',
        name: '删除',
        code: 'delete',
        icon: 'ant-design:delete-outlined',
        isDefault: true,
        isUse: true,
      },
    ];
    return filterButtonAuth(list);
  });

  const tableButtonConfig = computed(() => {
    return buttonConfigs.value?.filter((x) => !actionButtons.value.includes(x.code));
  });

  const actionButtonConfig = computed(() => {
    return buttonConfigs.value?.filter((x) => actionButtons.value.includes(x.code));
  });

  const btnEvent = {
    view: handleView,
    add: handleAdd,
    edit: handleEdit,
    delete: handleDelete,
    xiafa: handleXiafa,
  };

  const { currentRoute } = useRouter();

  const formIdComputedRef = computed(() => currentRoute.value.meta.formId as string);
  provide<Ref<string>>('currentFormId', formIdComputedRef);

  const selectedKeys = ref<string[]>([]);
  const selectedRowsData = ref<any[]>([]);

  const [registerModal, { openModal }] = useModal();

  const [registerTable, { reload }] = useTable({
    title: 'Scjh列表',
    api: getMesProductionPlanPage,
    rowKey: 'id',
    columns: filterColumns,
    pagination: {
      pageSize: 10,
    },
    formConfig: {
      labelWidth: 100,
      schemas: searchFormSchema,
      fieldMapToTime: [],
      showResetButton: false,
    },
    bordered: false,
    beforeFetch: (params) => {
      pageParamsInfo.value = { ...params, FormId: formIdComputedRef.value, PK: 'id' };
      return pageParamsInfo.value;
    },
    afterFetch: (res) => {
      selectedKeys.value = [];
      selectedRowsData.value = [];
    },
    useSearchForm: true,
    showTableSetting: true,

    striped: false,
    actionColumn: {
      width: 195,
      title: '操作',
      dataIndex: 'action',
      slots: { customRender: 'action' },
    },
    tableSetting: {
      size: false,
    },
    customRow,
    isAdvancedQuery: false,
    querySelectOption: JSON.stringify(searchFormSchema),
    objectId: formIdComputedRef.value, ////系统表单formId,自定义表单releaseId的id值
  });

  function buttonClick(code) {
    btnEvent[code]();
  }

  function handleAdd() {
    openModal(true, { isUpdate: false });
  }

  async function handleEdit(record: Recordable) {
    const hasNonDraft = record.zt !== '草稿';
    if (hasNonDraft) {
      Modal.warning({
        title: '提示',
        content: '已下发任务无法编辑',
      });
      return;
    }
    let field = 'id';
    try {
      let hasIn = handleHasEnableLocke(buttonConfigs.value, 'edit');
      if (hasIn) {
        let res = await handleOpenFormEnableLockeData(record[field], formIdComputedRef.value);
        if (res !== null) {
          return;
        }
      }

      let info = {
        id: record[field],

        isUpdate: true,
      };

      openModal(true, info);
    } catch (error) {}
  }

  function handleDelete(record: Recordable) {
    deleteList([record.id]);
  }

  function deleteList(ids) {
    Modal.confirm({
      title: '提示信息',
      icon: createVNode(ExclamationCircleOutlined),
      content: '是否确认删除？',
      okText: '确认',
      cancelText: '取消',
      onOk() {
        deleteMesProductionPlan(ids).then((_) => {
          handleSuccess();
          notification.success({
            message: 'Tip',
            description: t('删除成功！'),
          });
        });
      },
      onCancel() {},
    });
  }

  function onSelectChange(selectedRowKeys: [], selectedRows) {
    selectedKeys.value = selectedRowKeys;
    selectedRowsData.value = selectedRows;
  }

  function customRow(record: Recordable) {
    return {
      onClick: () => {
        let selectedRowKeys = [...selectedKeys.value];
        if (selectedRowKeys.indexOf(record.id) >= 0) {
          let index = selectedRowKeys.indexOf(record.id);
          selectedRowKeys.splice(index, 1);
        } else {
          selectedRowKeys.push(record.id);
        }
        selectedKeys.value = selectedRowKeys;
      },
      ondblclick: () => {
        if (record.isCanEdit && hasPermission('scjh:edit')) {
          handleEdit(record);
        }
      },
    };
  }

  function handleSuccess() {
    selectedKeys.value = [];
    selectedRowsData.value = [];
    reload();
  }

  function handleFormSuccess() {
    handleSuccess();
    handleCloseFormEnableLocke(buttonConfigs.value, 'edit');
  }

  function handleFormCancel() {
    handleCloseFormEnableLocke(buttonConfigs.value, 'edit');
  }

  function handleView(record: Recordable) {
    let info = {
      isView: true,
      id: record.id,
    };

    openModal(true, info);
  }

  function handleXiafa(record: Recordable) {
    Modal.confirm({
      title: t('提示信息'),
      icon: createVNode(ExclamationCircleOutlined),
      content: t('是否下发？'),
      okText: t('确认'),
      cancelText: t('取消'),
      async onOk() {
        if (selectedKeys.value.length === 0) {
          Modal.warning({
            title: '提示',
            content: '请选择计划',
          });
          return;
        }

        const hasNonDraft = selectedRowsData.value.some((item) => item.zt !== '草稿');
        if (hasNonDraft) {
          Modal.warning({
            title: '提示',
            content: '非草稿计划无法下发任务任务',
          });
          return;
        }
        const ids = selectedRowsData.value.map((x) => x.id);
        issueMesProductionPlan(ids).then((_) => {
          handleSuccess();
          notification.success({
            message: 'Tip',
            description: '下发成功！',
          });
        });
      },
      onCancel() {},
    });
  }

  function getLessActions(record: Recordable) {
    let list = getActions(record);
    return list.slice(0, listSpliceNum.value);
  }

  function getMoreActions(record: Recordable) {
    let list = getActions(record);
    return list.slice(listSpliceNum.value);
  }

  function getActions(record: Recordable): ActionItem[] {
    record.isCanEdit = false;

    let actionsList: ActionItem[] = [];
    actionButtonConfig.value?.map((button) => {
      if (!record?.workflowData?.processId) {
        record.isCanEdit = true;
        actionsList.push({
          ...button,

          auth: `scjh:${button.code}`,
          label: button?.name,
          color: button.code === 'delete' ? 'error' : undefined,
          onClick: btnEvent[button.code]?.bind(null, record),
        });
      } else {
        if (!['edit', 'delete'].includes(button.code)) {
          actionsList.push({
            auth: `scjh:${button.code}`,
            label: button?.name,
            onClick: btnEvent[button.code]?.bind(null, record),
          });
        }
      }
    });
    return actionsList;
  }
</script>
<style lang="less" scoped>
  :deep(.ant-table-selection-col) {
    width: 50px;
  }

  .show {
    display: flex;
  }

  .hide {
    display: none !important;
  }
</style>
